unit FormMain;

interface

uses
   Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls;

const

   // input and out buffer size constants...
   BufferInSize  = 64;
   BufferOutSize = 64;


type

   // input and output buffers...
   TBufferIn = array[0..BufferInSize] of byte;
   TBufferOut = array[0..BufferOutSize] of byte;

   // main form
   TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
      procedure FormCreate(Sender: TObject);
      procedure FormDestroy(Sender: TObject);
   private
      function USBEvent(var Msg: TMessage): Boolean;
   public
      FBufferIn:TBufferIn;
      FBufferOut:TBufferOut;
   end;

var
  Form1: TForm1;

implementation

uses
   cUSBInterface,
   cUSBInterfaceTypes;

const

   // vendor and product ID constants...
   VENDOR_ID           = 4660;
   PRODUCT_ID          = 1;

   // Other Contansts
   CRLF          = #13#10;
   CLIType_SDMF  = 4;
   CLIType_MDMF  = 128;

Var
  pckRcvd : Long;

{$R *.DFM}

Procedure ManuplatePackage(CLIType : Byte; PacketLength : Byte; PortNumber : Char; CLIPackage : String);
Const
    // Field Type Constants
    FT_DateTime     = #1;
    FT_CallerNumber = #2;
    FT_CallerName   = #7;
    FT_CalleeNumber = #34;

Var
    i : Integer;

    sLength     : String;
    sDateTime   : String;
    sCaller     : String;
    sCallee     : String;
    sCallerName : String;
    sUnknown    : String;

    xLength     : Integer;

Begin
   Str(PacketLength,sLength);

   Form1.label3.Caption := 'Port Number              : ' + PortNumber;
   If CLIType = CLIType_SDMF
      Then Form1.label4.Caption := 'Packet Type              : SDMF'
      Else Form1.label4.Caption := 'Packet Type              : MDMF';
   Form1.label5.Caption := 'Packet Length            : ' + sLength;

   sDateTime   := '';
   sCaller     := '';
   sCallee     := '';
   sCallerName := '';
   sUnknown    := '';

   If CLIType = CLIType_SDMF
      Then Begin
           sDateTime := Copy(CLIPackage,2,8);
           sCaller   := Copy(CLIPackage,10,Packetlength-8);
      End
      Else Begin
           i := 2;
           While i <= PacketLength
              Do Begin
                 if CLIPackage[i] = FT_DateTime
                    Then Begin
                        xLength := Ord(CLIPackage[i+1]);
                        sDateTime := Copy(CLIPackage,i+2,xLength);
                        i := i + xLength + 1;
                    End

                 Else if CLIPackage[i] = FT_CallerNumber
                    Then Begin
                        xLength := Ord(CLIPackage[i+1]);
                        sCaller := Copy(CLIPackage,i+2,xLength);
                        i := i + xLength + 1;
                    End

                 Else if CLIPackage[i] = FT_CalleeNumber
                    Then Begin
                        xLength := Ord(CLIPackage[i+1]);
                        sCallee := Copy(CLIPackage,i+2,xLength);
                        i := i + xLength + 1;
                    End

                 Else if CLIPackage[i] = FT_CallerName
                    Then Begin
                        xLength := Ord(CLIPackage[i+1]);
                        sCallerName := Copy(CLIPackage,i+2,xLength);
                        i := i + xLength + 1;
                    End

                 Else Begin
                        xLength := Ord(CLIPackage[i+1]);
                        sUnknown := Copy(CLIPackage,i+2,xLength);
                        i := i + xLength + 1;
                    End;

                 i := i +1;
              End;
      End;

   Form1.label6.Caption := 'Date And Time (MMDDHHMM) : ' + sDateTime;
   Form1.label7.Caption := 'Caller                   : ' + sCaller;
   Form1.label8.Caption := 'Callee                   : ' + sCallee;
End;


Procedure HIDSendData( OutData : String );
Var

    i : Integer;
    DevHandle  : Cardinal;
    QBufferOut : TBufferIn;

Begin
   For i := 0 To BufferOutSize
      Do QBufferOut[i] := 0;

   QBufferOut[0] := 0;  // First Byte Alwayes REPORT ID

   For i := 1 To Length(OutData)
      Do QBufferOut[i] := Byte(OutData[i]);

   DevHandle := GetHandle(VENDOR_ID, PRODUCT_ID);
   Write(DevHandle,@QBufferOut);
End;


Function TestCheckDigit(InData : String; PacketLength : Byte) : Boolean;
Var
     i : Byte;
     Res : Boolean;
     pDigit : Byte;

Begin
   pDigit := 0;
   For i := 2 To PacketLength+3 Do pDigit := (pDigit + Ord(inData[i]));
   pDigit := ($100 - pDigit);
   TestCheckDigit := (pDigit = Ord(inData[PacketLength+4]));
End;


Procedure DataArrival(InData : String);
Var
       i : Byte;

       PacketLength : Byte;
       PortNumber   : Char;
       CLIType      : Byte;
       CLIPackage   : String;

       sPckRcvd     : String;

Begin
   pckRcvd := pckRcvd + 1;
   Str(pckRcvd, sPckRcvd);

   if Pos(CRLF,InData) > 0
      Then Begin
         If Copy(InData,1,3) = 'ENQ' Then HIDSendData('ACK'+CRLF)
         else If Copy(InData,1,3) = 'ETB' Then HIDSendData('ACK'+CRLF)
         else If Copy(InData,1,3) = 'STA' Then Form1.Label2.Caption := 'Last Line Event Detected : ' + Copy(InData,5,100);
      end
      Else Begin
         HIDSendData('DCK'+CRLF);

         PortNumber := Char(InData[1]);
         CLIType    := Byte(InData[2]);

         if (PortNumber In ['A','B','C','D','S']) And ((CLIType = CLIType_SDMF) Or (CLIType = CLIType_MDMF))
            then begin
                 PacketLength := Byte(Indata[3]);

                 if PacketLength < 64
                    Then Begin
                       CLIPackage := '';
                       For i := 0 To PacketLength Do CLIPackage := CLIPackage + InData[i+3];

                       if TestCheckDigit(InData, PacketLength) then ManuplatePackage(CLIType, PacketLength, PortNumber, CLIPackage );
                    end;
            End;
      End;
End;


{
****************************************************************************
* Name    : Create                                                         *
* Purpose : Create the main form                                           *
****************************************************************************
}
procedure TForm1.FormCreate(Sender: TObject);
begin
   Application.HookMainWindow(USBEvent);
   Connect(Application.Handle);
end;
{
****************************************************************************
* Name    : Destroy                                                        *
* Purpose : Free the main form                                             *
****************************************************************************
}
procedure TForm1.FormDestroy(Sender: TObject);
begin
   Application.UnHookMainWindow(USBEvent);
end;
{
****************************************************************************
* Name    : USBEvent                                                       *
* Purpose : DLL message handler hook                                       *
****************************************************************************
}
function TForm1.USBEvent(var Msg: TMessage): Boolean;
var

   i : Integer;
   DevHandle  : cardinal;
   TextBuffer : String;

begin
  result := False;
  if Msg.Msg = WM_HID_EVENT then
  begin
     case Msg.WParam of

        NOTIFY_PLUGGED :
        begin
           DevHandle := Msg.LParam;
           if (GetVendorID(DevHandle) = VENDOR_ID) and (GetProductID(DevHandle) = PRODUCT_ID) then
           begin
              Label1.Caption := 'CID EASY CONNECTED';
           end;
           result := true;
        end;

        NOTIFY_UNPLUGGED :
        begin
           DevHandle := Msg.LParam;
           if (GetVendorID(DevHandle) = VENDOR_ID) and (GetProductID(DevHandle) = PRODUCT_ID) then
           begin
              Label1.Caption := 'CID EASY DISCONNECTED';
           end;
           result := true;
        end;

        NOTIFY_CHANGED :
        begin
           DevHandle := GetHandle(VENDOR_ID,PRODUCT_ID);
           SetReadNotify(DevHandle,true);
           result := true;
        end;

        NOTIFY_READ :
        begin
           DevHandle := Msg.LParam;
           if (GetVendorID(DevHandle) = VENDOR_ID) and (GetProductID(DevHandle) = PRODUCT_ID) then
           begin
               // Read Data - First byte in data is always report ID...
               Read(DevHandle,@FBufferIn);

               // Convert data as string
               Textbuffer := '';
               For i := 1 to Bufferinsize
                  Do If fBufferIn[i] > 0
                     Then Textbuffer :=  Textbuffer + Chr(fBufferIn[i]);

               // And then manuplate data
               DataArrival( Textbuffer );
           end;
           result := true;
        end;
     end;
  end;
end;


end.


